#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <stdbool.h>

#include "base.h"
#include "clan.h"


Jeu jeu_vide()
{
    Jeu j;
    j.clans=NULL;
    return j;
}

Population jeu_adresse_chef(Population mclan )
{
    Population find = mclan;
    while (find->next_pop!=NULL)
    {
        find = find ->next_pop;
    }
    // Chef du clan :
    return find;
}


void jeu_print_pop(Jeu j)
{
    printf("Listes des joueurs : ");
    while(j.pop!=NULL)
    {
        // acceder a l'identifiant du joueur pour l'afficher
        Nat player = per_id(j.pop->per);
        printf(" %d", player);
        j.pop = j.pop->next_pop;
    }
    printf("/n");
}


void jeu_print_clan(Jeu j, Population mclan)
{
    printf("Listes des membres du clan demandé : ");

    // trouver le chef avec jeu_adresse_chef :
    Population chef = jeu_adresse_chef(mclan);

    // parcourir tous les clans pour trouver le clan qui a ce chef :
    Clans ptr_clan = j.clans;    
    while (ptr_clan!=NULL && chef!=ptr_clan->dernier)
    {
        ptr_clan = ptr_clan->next_clan ;
    }

    // afficher tous les membres de ce clan (en commenceant par le premier)

    Membre * ptr_membre = ptr_clan->premier;
    while(ptr_membre != NULL)
    {
        // acceder a l'identifiant du joueur pour l'afficher
        Nat player = per_id(ptr_membre->per);
        printf(" %d", player);
        ptr_membre = ptr_membre->next_comp;
    }
    printf("/n");
}

Jeu jeu_fusion(Jeu j, Clans clan1, Clans clan2)
{
    Jeu ptr_jeu = j;
    Clans ptr_clan1= clan1;
    Clans ptr_clan2= clan2;
    // Concatener d'abord le clans1 et clan 2 :

    Membre * ptr_dernier_clan1 =  ptr_clan1->dernier;

    ptr_dernier_clan1->next_comp = ptr_clan2->premier;

    clan1->dernier = clan2->dernier;

    // supprimer clan2

    Clans ptr_clan = j.clans;

    while(ptr_clan->next_clan!=clan2)
    {
        ptr_clan = ptr_clan->next_clan;
    }
    
    Clans asup = ptr_clan->next_clan;

    ptr_clan->next_clan = ptr_clan->next_clan->next_clan; //  ou asup->next_clan

    free(asup);

    return j;
}


Jeu jeu_adj_joueur(Jeu j, personne p)
{
    Clans ptr_jeu = j.clans;
    Membre * ptr_membre = ptr_jeu->premier;

    // Checker si la personne p existe deja dans un clan :
    while(ptr_jeu!=NULL)
    {
        Nat player = per_id(ptr_membre->per);
        if (player==p.id)
        {
            printf("error");
            return j;
        }
        ptr_jeu = ptr_jeu->next_clan;
    }

    // ajouter cette nouvelle personne dans un nouveau clan :

    Clans new = MALLOC(StrClans);
    

}