#include "tp2_ex2.h"

// Crée une file vide
File filenouv() {
    File f;
    f.h = NULL;
    f.q = NULL;
    return f;
}

// Ajoute un élément à la fin de la file
File adjq(File f, Nat val) {
    Strfile* nouv = MALLOC(Strfile);
    nouv->v = val;
    nouv->s = NULL;

    if (vide(f)) {          // Si la file est vide
        f.h = nouv;         // Le nouvel élément est à la fois la tête...
        f.q = nouv;         // ...et la queue.
    } else {                // Sinon
        f.q->s = nouv;      // Ajouter à la fin
        f.q = nouv;         // Mettre à jour la queue
    }

    return f;
}

// Supprime l'élément en tête de la file
File supt(File f) {
    Strfile* tmp = f.h;
    f.h = f.h->s;
    FREE(tmp);
    return f;
}

// Vérifie si la file est vide
Bool vide(File f) {
    return f.h == NULL;
}

// Retourne l'élément en tête de la file
Nat tete(File f) {
     return f.h->v;
}

// Retourne la longueur de la file
Nat longueur(File f) {
    Nat len = 0;
    Strfile* tmp = f.h;
    while (tmp) {
        len++;
        tmp = tmp->s;
    }
    return len;
}

// Libère la mémoire de la file
void liberer(File f) {
    while (!vide(f)) {
        f = supt(f);
    }
}
