#include "tp2_ex3.h"

// Crée une file vide
File filongouv() {
    File f;
    f.q = NULL;
    return f;
}

// Vérifie si la file est vide
Bool vide(File f) {
    return f.q == NULL;
}

// Ajoute un élément à la file
File adjq(File f, Nat val) {
    Strfile* nouv = MALLOC(Strfile);
    nouv->v = val;

    if (vide(f)) {          // Cas où la file est vide
        nouv->s = nouv;     // Le seul élément pointe sur lui-même
        f.q = nouv;
    } else {                // Cas général
        nouv->s = f.q->s;   // Le nouvel élément pointe sur la tête
        f.q->s = nouv;      // L'ancien dernier élément pointe sur le nouveau
        f.q = nouv;         // Mettre à jour la queue
    }

    return f;
}

// Supprime l'élément en tête de la file
File supt(File f) {
    Strfile* tete = f.q->s; // Pointeur vers la tête
    if (tete == f.q) {      // Cas où la file a un seul élément
        f.q = NULL;
    } else {                // Cas général
        f.q->s = tete->s;   // La queue pointe sur le deuxième élément
    }
    FREE(tete);             // Libérer l'élément supprimé
    return f;
}

// Retourne l'élément en tête de la file
Nat tete(File f) {
    return f.q->s->v;   // La tête est l'élément suivant la queue
}

// Calcule la longueur de la file
Nat longueur(File f) {
    if (vide(f)) {
        return 0;
    }
    Nat lon = 1;
    Strfile* courant = f.q->s; // Commencer à la tête
    while (courant != f.q) {  // Parcourir jusqu'à revenir à la queue
        lon++;
        courant = courant->s;
    }
    return lon;
}

// Libère toute la mémoire de la file
void liberer(File f) {
    while (!vide(f)) {
        f = supt(f);
    }
}
