#include "base.h"

// Structure d'un nœud de la file
typedef struct strfile {
    Nat v;                  // Valeur
    struct strfile* s;      // Pointeur vers le prochain élément
} Strfile;

// Structure de la file circulaire
typedef struct sfile{
    Strfile* q;             // Pointeur vers la queue de la file
} File;

// Fonctions principales

File filenouv();                  // Crée une file vide

File adjq(File f, Nat val);       // Ajoute un élément à la file

//Precondition : File non cide
//pre supt(f) = !vide(f)
File supt(File f);                // Supprime l'élément en tête

Bool vide(File f);                // Vérifie si la file est vide

//Precondition : File non cide
//pre tete(f) = !vide(f)
Nat tete(File f);                 // Retourne l'élément en tête

Nat longueur(File f);             // Retourne la longueur de la file

void liberer(File f);             // Libère la mémoire de la file
