#include "tp3_ex1.h"

// Question 1

// Crée une liste vide
Liste listenouv() {
    return NULL;
}

// Retourne la valeur en tête de la liste
Nat tete(Liste l){
    return l->v;
}

// Ajoute un élément en tête
Liste adjt(Liste l, Nat x) {
    Liste nouv = MALLOC(Strliste);
    nouv->v = x;
    nouv->s = l;
    return nouv;
}

// Supprime l'élément en tête
Liste supt(Liste l) {
    if (est_vide(l)) {
        printf("Liste vide !\n");
        return l;
    }
    Liste tmp = l;
    l = l->s;
    FREE(tmp);
    return l;
}

// Retourne la longueur de la liste
Nat longueur(Liste l){
    Nat compt = 0;
    Liste l1 = l;
    while (l1!=NULL){
        compt++;
        l1 = l1 -> s;
    }
    return compt;
}

// Vérifie si la liste est vide
Bool est_vide(Liste l) {
    return l == NULL;
}

// Vérifie l'appartenance d'un élément
Bool appartient(Liste l, Nat x){
    Liste l1 = l;
    while (l1 != NULL) {
        if (l1->v == x) {
            return vrai;  
        }
        l1 = l1->s;
    }
    return faux;
}

// Question 2

// Retourne la première occurrence d'un élément
Liste premiere_Occ(Liste l, Nat x) {
    while (l) {
        if (l->v == x) {
            return l;
        }
        l = l->s;
    }
    return NULL;
}

// Change la première occurrence d'un élément
Liste change_pemiere_Occ(Liste l, Nat x, Nat y) {
    Liste occ = premiere_Occ(l, x);
    if (occ!=NULL) {
        occ->v = y;
    }
    return l;
}

// Supprime la première occurrence d'un élément
Liste supprime_premiere_Occ(Liste l, Nat x) {
    if (est_vide(l)) {
        return l;
    }
    if (l->v == x) {
        return supt(l);
    }
    Liste courant = l;
    while (courant->s && courant->s->v != x) {
        courant = courant->s;
    }
    if (courant->s) {
        Liste tmp = courant->s;
        courant->s = tmp->s;
        FREE(tmp);
    }
    return l;
}

// Question 3

// Retourne la valeur en queue
Nat queue(Liste l) {
    while (l->s) {
        l = l->s;
    }
    return l->v;
}

// Ajoute un élément en queue
Liste adjq(Liste l, Nat x) {
    Liste nouv = MALLOC(Strliste);
    nouv->v = x;
    nouv->s = NULL;

    if (est_vide(l)) {
        return nouv;
    }
    Liste courant = l;
    while (courant->s) {
        courant = courant->s;
    }
    courant->s = nouv;
    return l;
}

// Supprime l'élément en queue
Liste supq(Liste l) {
    if (est_vide(l)) {
        printf("Liste vide !\n");
        return l;
    }
    if (!l->s) {
        FREE(l);
        return NULL;
    }
    Liste courant = l;
    while (courant->s->s) {
        courant = courant->s;
    }
    FREE(courant->s);
    courant->s = NULL;
    return l;
}

// Question 4

// Retourne l'élément à la i-ème position
Nat acces_ieme(Liste l, int i) {
    for (int index = 1; index < i; index++) {
        l = l->s; // Avancer dans la liste
    }
    return l->v; // Retourner la valeur au i-ème élément
}


// Ajoute un élément à la i-ème position
Liste ajout_ieme_position(Liste l, int i, Nat x) {
    // Cas 1 : La liste est vide ou insertion en tête
    if (i == 1 || est_vide(l)) {
        return adjt(l, x);
    }

    // Cas 2 et 3 : Liste avec au moins 1 élément, insertion ailleurs
    Liste courant = l;
    for (int index = 1; index < i - 1 && courant->s; index++) {
        courant = courant->s; // Avancer jusqu'à (i-1)-ème position
    }

    // Création du nouveau nœud
    Liste nouv = MALLOC(Strliste);
    nouv->v = x;
    nouv->s = courant->s; // Relier au reste de la liste
    courant->s = nouv;    // Relier au précédent

    return l;
}

// Supprime l'élément à la i-ème position
Liste supp_ieme_position(Liste l, int i) {

    // Cas de la liste vide ou indice invalide
    if (est_vide(l) || i < 1 || longueur(l) < i) {
        return l; // Aucun changement
    }
    // Cas où l'élément à supprimer est en tête
    if (i == 1) {
        return supt(l);
    }
    // Itérer jusqu'à la position (i - 1)
    Liste courant = l;
    for (int index = 1; index < i - 1; index++) {
        courant = courant->s;
    }

    // Si courant est nul ou courant->s est nul, rien à supprimer
    if (courant == NULL || !courant->s) {
        return l;
    }

    // Supprimer l'élément à la position i
    Liste tmp = courant->s;
    courant->s = tmp->s; // Relier l'élément précédent au suivant
    FREE(tmp);           // Libérer la mémoire de l'élément supprimé

    return l;
}