#include "tp3_ex2.h"

// Crée une liste vide
Liste listenouv() {
    return NULL; // Une liste circulaire vide est représentée par NULL
}

// Retourne la valeur en tête
Nat tete(Liste l) {
    return l->v; // Le pointeur `l` pointe sur la tête
}

// Ajoute un élément en tête
Liste adjt(Liste l, Nat x) {
    Liste nouv = MALLOC(Strliste);
    nouv->v = x;

    if (est_vide(l)) { // Cas d'une liste vide
        nouv->s = nouv; // Le nouvel élément pointe sur lui-même
        return nouv;
    }

    // Insertion en tête pour une liste non vide
    Liste courant = l;
    while (courant->s != l) {
        courant = courant->s; // Trouver le dernier élément
    }
    courant->s = nouv; // Relier le dernier élément au nouveau
    nouv->s = l;       // Le nouvel élément pointe sur l'ancien premier
    return nouv;       // Retourner le nouveau premier
}

// Supprime l'élément en tête
Liste supt(Liste l) {
    if (est_vide(l)) {
        printf("Liste vide !\n");
        return l;
    }

    if (l->s == l) { // Cas d'un seul élément
        FREE(l);
        return NULL;
    }

    Liste dernier = l;
    while (dernier->s != l) {
        dernier = dernier->s; // Trouver le dernier élément
    }
    Liste tmp = l;
    dernier->s = l->s; // Relier le dernier au deuxième
    l = l->s;          // Avancer la tête
    FREE(tmp);
    return l;
}

// Retourne la longueur de la liste
Nat longueur(Liste l) {
    if (est_vide(l)) {
        return 0;
    }

    Nat len = 1;
    Liste courant = l->s;
    while (courant != l) {
        len++;
        courant = courant->s;
    }
    return len;
}

// Vérifie si la liste est vide
Bool est_vide(Liste l) {
    return l == NULL;
}

// Vérifie l'appartenance d'une valeur
Bool appartient(Liste l, Nat x) {
    if (est_vide(l)) {
        return faux;
    }

    Liste courant = l;
    do {
        if (courant->v == x) {
            return vrai;
        }
        courant = courant->s;
    } while (courant != l);
    return faux;
}

// Retourne la valeur en queue
Nat queue(Liste l) {
    Liste courant = l;
    while (courant->s != l) {
        courant = courant->s;
    }
    return courant->v;
}

// Ajoute un élément en queue
Liste adjq(Liste l, Nat x) {
    Liste nouv = MALLOC(Strliste);
    nouv->v = x;

    if (est_vide(l)) { // Cas d'une liste vide
        nouv->s = nouv;
        return nouv;
    }

    Liste courant = l;
    while (courant->s != l) {
        courant = courant->s; // Trouver le dernier élément
    }
    courant->s = nouv; // Relier le dernier au nouveau
    nouv->s = l;       // Relier le nouveau au premier
    return l;          // Retourner la tête inchangée
}

// Supprime l'élément en queue
Liste supq(Liste l) {
    if (est_vide(l)) {
        printf("Liste vide !\n");
        return l;
    }

    if (l->s == l) { // Cas d'un seul élément
        FREE(l);
        return NULL;
    }

    Liste courant = l;
    while (courant->s->s != l) {
        courant = courant->s; // Trouver l'avant-dernier élément
    }
    FREE(courant->s); // Supprimer le dernier
    courant->s = l;   // Relier l'avant-dernier au premier
    return l;
}
