#include "tp4_ex1.h"

// Crée une liste vide
Liste listenouv() {
    return NULL; // Une liste vide est représentée par NULL
}

// Retourne la valeur en tête
Nat tete(Liste l) {
    return l->v;
}

// Ajoute un élément en tête
Liste adjt(Liste l, Nat x) {
    Liste nouv = MALLOC(StrListe);
    nouv->v = x;
    nouv->s = l;
    nouv->p = NULL;
    if (l != NULL) {
        l->p = nouv;
    }
    return nouv;
}

// Supprime l'élément en tête
Liste supt(Liste l) {
    if (est_vide(l)) {
        printf("Liste vide !\n");
        return l;
    }
    Liste tmp = l;
    l = l->s; // Avancer la tête
    if (l != NULL) {
        l->p = NULL;
    }
    FREE(tmp);
    return l;
}

// Retourne la longueur de la liste
Nat longueur(Liste l) {
    Nat len = 0;
    while (l) {
        len++;
        l = l->s;
    }
    return len;
}

// Vérifie si la liste est vide
Bool est_vide(Liste l) {
    return l == NULL;
}

// Vérifie l'appartenance d'une valeur
Bool appartient(Liste l, Nat x) {
    while (l) {
        if (l->v == x) {
            return vrai;
        }
        l = l->s;
    }
    return faux;
}

// Retourne la valeur à la i-ème position
Nat acces_ieme(Liste l, Nat i) {
    // Parcourir jusqu'à la position i
    for (int index = 0; index < i; index++) {
        l = l->s;
    }
    return l->v; // Retourner la valeur
}


// Ajoute un élément à la i-ème position
Liste ajout_ieme_position(Liste l, Nat i, Nat x) {
    // Cas : Ajout en tête
    if (i == 0) {
        return adjt(l, x); // Utiliser la fonction existante pour ajouter en tête
    }
    // Cas : Ajout ailleurs
    Liste courant = l;
    for (int index = 0; index < i - 1; index++) {
        courant = courant->s; // Avancer jusqu'à (i-1)-ème élément
    }
    // Insérer après `courant`
    Liste nouv = MALLOC(StrListe);
    nouv->v = x;
    nouv->s = courant->s;
    nouv->p = courant;
    if (courant->s != NULL) {
        courant->s->p = nouv;
    }
    courant->s = nouv;

    return l;
}


// Supprime l'élément à la i-ème position
Liste supp_ieme_position(Liste l, Nat i) {
    // Cas : Suppression en tête
    if (i == 0) {
        return supt(l); // Utiliser la fonction existante pour supprimer en tête
    }
    // Cas : Suppression ailleurs
    Liste courant = l;
    for (int index = 0; index < i; index++) {
        courant = courant->s; // Avancer jusqu'à l'élément à la position i
    }
    // Mettre à jour les liens
    if (courant->p != NULL) {
        courant->p->s = courant->s;
    }
    if (courant->s != NULL) {
        courant->s->p = courant->p;
    }
    FREE(courant); // Libérer la mémoire de l'élément supprimé
    return l;
}

// Change l'élément à la i-ème position
Liste changement_ieme_position(Liste l, Nat i, Nat x) {
    Liste courant = l;

    // Parcourir jusqu'à la i-ème position
    for (Nat index = 0; index < i; index++) {
        courant = courant->s;
    }

    // Modifier la valeur
    courant->v = x;

    return l;
}
