#include "base.h"

// Structure pour une liste doublement chaînée
typedef struct sldc {
    Nat v;                   // Valeur stockée
    struct sldc *s;          // Pointeur vers le suivant
    struct sldc *p;          // Pointeur vers le précédent
} StrListe, *Liste;

// Fonctions standard

Liste listenouv();                         // Crée une liste vide

//Precondition : liste non vide
Nat tete(Liste l);                         // Retourne la valeur en tête

Liste adjt(Liste l, Nat x);                // Ajoute un élément en tête

Liste supt(Liste l);                       // Supprime l'élément en tête

Nat longueur(Liste l);                     // Retourne la longueur de la liste

Bool est_vide(Liste l);                    // Vérifie si la liste est vide

Bool appartient(Liste l, Nat x);           // Vérifie l'appartenance d'une valeur


// Fonctions pour i-ème position

//Preconditions : liste non vide et indice i est 0 <= i <= longueur(l)-1
Nat acces_ieme(Liste l, Nat i);            // Retourne la valeur à la i-ème position

//Preconditions : liste non vide et indice i est 0 <= i <= longueur(l)-1
Liste ajout_ieme_position(Liste l, Nat i, Nat x); // Ajoute un élément à la i-ème position

//Preconditions : liste non vide et indice i est 0 <= i <= longueur(l)-1
Liste supp_ieme_position(Liste l, Nat i);  // Supprime l'élément à la i-ème position

//Preconditions : liste non vide et indice i est 0 <= i <= longueur(l)-1
Liste changement_ieme_position(Liste l, Nat i, Nat x); // Change l'élément à l'indice i

