#include "tp4_ex2.h"

// Initialise un itérateur sur une liste
Iter init(Liste L) {
    Iter i = MALLOC(struct { Liste first; Liste cur; Bool fin; });
    i->first = L;
    i->cur = L;
    i->fin = (L == NULL); // Fin si la liste est vide
    return i;
}

// Vérifie si l'itérateur est en fin de liste
Bool end(Iter i) {
    return i->fin;
}

// Avance l'itérateur au prochain élément
Iter next(Iter i) {
    if (end(i)) {
        printf("Itérateur déjà en fin de liste !\n");
        return i;
    }
    i->cur = i->cur->s;
    i->fin = (i->cur == NULL); // Met à jour le statut fin
    return i;
}

// Recule l'itérateur au précédent élément
Iter prev(Iter i) {
    if (i->cur == i->first) {
        printf("Impossible de reculer, déjà au début !\n");
        return i;
    }
    i->cur = i->cur->p; // Reculer au précédent
    i->fin = faux;      // Si on recule, on n'est plus en fin
    return i;
}

// Retourne la valeur de l'élément courant
Nat value(Iter i) {
    return i->cur->v;
}

// Libère l'itérateur
void free_iter(Iter i) {
    FREE(i);
}

// Cherche un élément dans une liste avec un itérateur
Bool chercher_element(Liste l, Nat x) {
    Iter i = init(l); // Initialiser l'itérateur
    while (!end(i)) {
        if (value(i) == x) {
            free_iter(i); // Libérer l'itérateur
            return vrai;
        }
        next(i);
    }
    free_iter(i); // Libérer l'itérateur
    return faux;
}
