#include "tp5.h"

int main() {
    Jeu j = jeu_vide(); // Initialisation du jeu

    printf("=== Ajout de joueurs et création de clans ===\n");
    // Ajouter des joueurs
    j = jeu_adj_joueur(j, per_mk(1, 25, 'h'));
    j = jeu_adj_joueur(j, per_mk(2, 30, 'f'));
    j = jeu_adj_joueur(j, per_mk(3, 20, 'h'));
    j = jeu_adj_joueur(j, per_mk(4, 35, 'f'));

    // Afficher la population
    printf("\n--- Population initiale ---\n");
    jeu_print_pop(j);

    // Afficher le clan d'un joueur
    printf("\n--- Clan du joueur 1 ---\n");
    jeu_print_clan(j, j.clans->premier);

    printf("\n=== Fusion des clans ===\n");
    // Fusionner deux clans
    j = jeu_fusion(j, j.clans, j.clans->next_clan);

    // Afficher les clans après la fusion
    printf("\n--- Population après fusion ---\n");
    jeu_print_pop(j);

    printf("\n--- Clan après fusion ---\n");
    jeu_print_clan(j, j.clans->premier);

    printf("\n=== Retrait d'un joueur ===\n");
    // Retirer un joueur
    j = jeu_retire_joueur(j, 2);

    // Afficher la population après retrait
    printf("\n--- Population après retrait du joueur 2 ---\n");
    jeu_print_pop(j);

    printf("\n--- Clan après retrait ---\n");
    jeu_print_clan(j, j.clans->premier);

    printf("\n=== Tests sur les attributs de Personne ===\n");
    // Tester les opérations sur Personne
    Personne p = per_mk(5, 28, 'h');
    printf("Personne créée : ID = %u, Âge = %u, Genre = %c\n", per_id(p), per_age(p), per_genre(p));

    return 0;
}
