#include "base.h"

// Structures de données

typedef struct {
    Nat id;     // Identifiant unique
    Nat age;    // Âge du joueur
    Car genre;  // Genre ('h', 'f', etc.)
} Personne;

typedef struct stPer {
    Personne per;           // Données de la personne
    struct stPer* next_comp; // Compagnon suivant dans le clan
    struct stPer* next_pop;  // Prochain joueur dans la population
} *Population, Membre;

typedef struct stClan {
    Membre premier;     // Premier membre du clan
    Membre dernier;     // Dernier membre, représentant du clan
    struct stClan* next_clan; // Clan suivant
} *Clans, StrClan;

typedef struct {
    Population pop;  // Population entière
    Clans clans;     // Liste des clans
} Jeu;

// Opérations sur la structure Personne
Personne per_mk(Nat id, Nat age, Car genre); // Crée une personne
Nat per_id(Personne p);                      // Retourne l'identifiant d'une personne
Nat per_age(Personne p);                     // Retourne l'âge d'une personne
Car per_genre(Personne p);                   // Retourne le genre d'une personne

// Opérations sur le jeu
Jeu jeu_vide();                              // Crée un jeu vide
Population jeu_adresse_chef(Membre membre);  // Retourne l'adresse du chef d'un clan
void jeu_print_clan(Jeu j, Membre membre);   // Affiche les membres d'un clan
Jeu jeu_fusion(Jeu j, Clans clan1, Clans clan2); // Fusionne deux clans
void jeu_print_pop(Jeu j);                   // Affiche la population entière
Jeu jeu_adj_joueur(Jeu j, Personne p);       // Ajoute une personne et crée un nouveau clan
Jeu jeu_retire_joueur(Jeu j, Nat id);        // Retire un joueur du jeu

