#include "tele.h"

// Exo 1 :

Programme creer_programme(int d, char *nom)
{
    Programme new_prog;
    new_prog.nom_du_programme = nom;
    new_prog.duree = d;
    return new_prog;
}

Chaine creer_chaine(int n)
{
    Chaine new_chaine;
    new_chaine.h = -1;
    new_chaine.l = 0;
    new_chaine.numero = n;
    return new_chaine;
}

// préconde : Max 24 prog dans une chaine
Chaine ajouter_programme(Chaine c, Programme p)
{
    c.tab[c.l] = p;
    c.l++;
    if (c.h == -1)
        c.h = 0;
    return c;
}

Chaine defiler_programme(Chaine c)
{
    if (c.l == 0)
    {
        printf("Aucun programme.\n");
        exit(EXIT_FAILURE);
    }
    c.h++;
    c.l--;
    if (c.l == 0)
        c.h = -1;
    return c;
}

Programme programme_actuel(Chaine c)
{
    if (c.h == -1)
    {
        printf("Aucun programme.\n");
        exit(EXIT_FAILURE);
    }
    return c.tab[c.h];
}

bool chaine_vide(Chaine c)
{
    return (c.l == 0);
}

// Exo 2 :

Tele creer_tele()
{
    Tele new_tv = NULL;
    return new_tv;
}

Tele ajouter_chaine(Tele t, Chaine c)
{
    Tele new = MALLOC(Str_tele);
    new->c = c;
    if (t == NULL) // cas : aucune chaine (liste vide)
    {
        new->s = new;
        new->p = new;
        return new;
    }
    Tele actuel = t;
    while (actuel->s != t && c.numero >= actuel->c.numero)
    {
        actuel = actuel->s;
    }
    if (c.numero < t->c.numero)
        return new;
    return t;
}

// version supprimer la queue
/*
 * Tele supprimer_chaine(Tele t)
 * {
 *     if (t == NULL)
 *         return t;
 *     if (t->s == t)
 *     {
 *         FREE(t);
 *         return NULL;
 *     }
 *
 *     Tele queue = t->p;
 *     Tele nouvelle_queue = queue->p;
 *
 *     nouvelle_queue->s = t;
 *     t->p = nouvelle_queue;
 *
 *     free(queue);
 * }
 */

// version supprimer la tete

Tele supprimer_chaine(Tele t)
{
    if (t == NULL)
        return NULL;
    if (t->s == t)
    {
        free(t);
        return NULL;
    }
    Tele suivant = t->s;
    Tele precedent = t->p;
    precedent->s = suivant;
    suivant->p = precedent;
    free(t);
    return suivant;
}

bool tele_vide(Tele t)
{
    return (t == NULL);
}

Tele detruire_tele(Tele t)
{
    if (t == NULL)
        return NULL;
    Tele premier = t;
    Tele suivant;
    do
    {
        suivant = t->s;
        free(t);
        t = suivant;
    } while (t != premier);
    return NULL;
}

// Exo 3 :

Tele chaine_suivante(Tele t)
{
    if (t == NULL)
        return NULL;
    t = t->s;
    return t;
}

Tele chaine_precedente(Tele t)
{
    if (t == NULL)
        return NULL;
    t = t->p;
    return t;
}

Chaine chaine_actuel(Tele t)
{
    return t->c;
}

Tele chaine_n(Tele t, int i)
{
    if (t == NULL)
        return NULL;
    Tele depart = t;
    while (true)
    {
        if (t->c.numero == i)
            return t;
        t = t->s;
        if (t == depart)
            break;
    }
    return t;
}

void programme_tele_actuel(Tele t)
{
    if (t == NULL)
    {
        printf("La télé est éteinte ou aucune chaîne n'est disponible.\n");
    }

    Chaine chaine_actuelle = t->c;
    printf("Programme de la chaîne %d :\n", chaine_actuelle.numero);

    if (chaine_actuelle.l == 0)
    {
        printf("Aucun programme disponible sur cette chaîne.\n");
    }

    for (int i = 0; i < chaine_actuelle.l; i++)
    {
        Programme prog = chaine_actuelle.tab[i];
        printf("  - Programme %d : %s (%d heure%s)\n", i + 1, prog.nom_du_programme, prog.duree, prog.duree > 1 ? "s" : "");
    }
}

// Exo 4 :

Chaine avancer_dans_le_temps_chaine(Chaine c, int duree)
{
    int i = c.h;
    if (c.tab[i].duree >= duree)
    {
        c.tab[i].duree - duree;
        return c;
    }
    do
    {
        c.tab[i].duree - duree;
        i++;
    } while (i < c.l && duree >= 0); // ???
    return c;
}