#ifndef TELE_H
#define TELE_H
#include <stdio.h>
#include <stdbool.h>
#include <stdlib.h>
#include "base.h"

typedef struct programme
{
    int duree;              // Durée d'un programme en heure (minimumum 1heure)
    char *nom_du_programme; // Nom du programme (chaine de char)
} Programme;

typedef struct chaine
{                      // Une chaine de télé est une FILE de programme
    Programme tab[24]; // Tableau de maximum 24 programmes pour les 24h de la journée
    int h;             // index de la tete de file
    int l;             // longeur de la file
    int numero;        // numero de la chaine
} Chaine;

typedef struct str_tele
{                       // Une télé est une LISTE TRIEE DOUBLEMENT CHAINEE CIRCULAIRE de chaine
    Chaine c;           // chaine actuelle
    struct str_tele *s; // chaine suivante
    struct str_tele *p; // chaine précédente
} Str_tele, *Tele;

// EXO 1 : 5 points
//  -----------------------------------------------------------------------------------------------
Programme creer_programme(int d, char *nom);
Chaine creer_chaine(int n);
Chaine ajouter_programme(Chaine c, Programme p); // préconde : Max 24 prog dans une chaine
Chaine defiler_programme(Chaine c);
Programme programme_actuel(Chaine c); // préconde : Chaine non vide
bool chaine_vide(Chaine c);
// -----------------------------------------------------------------------------------------------

// EXO 2 : 5 points
//  -----------------------------------------------------------------------------------------------
Tele creer_tele();
Tele ajouter_chaine(Tele t, Chaine c);
Tele supprimer_chaine(Tele t);
bool tele_vide(Tele t);
Tele detruire_tele(Tele t); // Fonction qui free toutes les chaines d'une télé
// -----------------------------------------------------------------------------------------------

// EXO 3 : 5 points
//  -----------------------------------------------------------------------------------------------
Tele chaine_suivante(Tele t);
Tele chaine_precedente(Tele t);
Chaine chaine_actuel(Tele t); // précond : télé non vide
Tele chaine_n(Tele t, int i);
void programme_tele_actuel(Tele t); // fonction d'affichage
// -----------------------------------------------------------------------------------------------

// EXO 4 : 5 points
//  -----------------------------------------------------------------------------------------------
Chaine avancer_dans_le_temps_chaine(Chaine c, int duree);
Tele avancer_dans_le_temps(Tele t, int duree);
// -----------------------------------------------------------------------------------------------

#endif
